
Trigger.prototype.InitStartingTechnologies = function()
{
	let startingTechnologies = [
	"phase_town",
	"phase_town_generic",
	"phase_town_athen",
	"phase_city",
	"phase_city_generic",
	"phase_city_athen",
	];
	for (let i = 1; i < TriggerHelper.GetNumberOfPlayers(); ++i)
		QueryPlayerIDInterface(i).SetStartingTechnologies(startingTechnologies);
};

Trigger.prototype.GetPopCount = function(playerid)
{
	let count = QueryPlayerIDInterface(playerid).GetPopulationCount();
	let maxpop = QueryPlayerIDInterface(playerid).GetPopulationLimit();
	let popCounts = {count:count, maxpop:maxpop};
	return (popCounts);
};

Trigger.prototype.GetSpawnData = function(enemyUnitsKilled)
{
	let spawnUnit = {};
	if (enemyUnitsKilled < 5 )  {spawnUnit = "units/athen_infantry_slinger_b"} else
	if (enemyUnitsKilled < 7 )  {spawnUnit = "units/athen_infantry_javelinist_b"} else
	if (enemyUnitsKilled < 9 )  {spawnUnit = "units/athen_infantry_marine_archer_b"} else
	if (enemyUnitsKilled < 11) {spawnUnit = "units/athen_infantry_spearman_b"} else
	if (enemyUnitsKilled < 13) {spawnUnit = "units/athen_cavalry_javelinist_b"} else
	if (enemyUnitsKilled < 15) {spawnUnit = "units/athen_cavalry_swordsman_b"} else
	if (enemyUnitsKilled < 17) {spawnUnit = "units/athen_hero_iphicrates"} else
	if (enemyUnitsKilled < 19) {spawnUnit = "units/athen_hero_pericles"} else
	if (enemyUnitsKilled < 21) {spawnUnit = "units/athen_hero_themistocles"} else
	if (enemyUnitsKilled < 23) {spawnUnit = "units/athen_hero_xenophon"} else {
		spawnUnit = "units/athen_hero_xenophon";
	}
	return spawnUnit;
};

Trigger.prototype.GetTriggerPoint = function(player) 
{
	let point = {};
	if (player == 1) {point = "A"} else
	if (player == 2) {point = "B"} else
	if (player == 3) {point = "C"} else
	if (player == 4) {point = "D"} else {
		point = "A";
	}
	return point;
};

Trigger.prototype.SpawnUnits = function()
{
	let activePlayers = cmpPlayer.GetActivePlayers();
	let playerid;
	for (let i = 0; i < activePlayers.length; ++i)
		{
			let playerid = activePlayers[i];
			let popCounts = this.GetPopCount(playerid);
			if (popCounts.count < popCounts.maxpop) {
				let cmpStatisticsTracker = QueryPlayerIDInterface(playerid, IID_StatisticsTracker);
				let obj = cmpStatisticsTracker.GetStatistics();
				let unitTemplate = this.GetSpawnData(obj.enemyUnitsKilled.total);
				let triggerPoint = this.GetTriggerPoint(playerid);
				TriggerHelper.SpawnUnitsFromTriggerPoints(triggerPoint, unitTemplate, 1, playerid);
			};
		}
};

{
var cmpPlayer = Engine.QueryInterface(SYSTEM_ENTITY, IID_PlayerManager);
var cmpTrigger = Engine.QueryInterface(SYSTEM_ENTITY, IID_Trigger);
cmpTrigger.RegisterTrigger("OnInterval", "SpawnUnits", {
	"delay": 0,
	"interval": 5 * 1000,
	"enabled": true
	});
cmpTrigger.state = "initialising";
cmpTrigger.InitStartingTechnologies();
}



